%{open Types
%}


/* tokens pour les commandes */
%token QUITTER FIN AIDE PREUVE VIRGULE NON PARG PARD 
%token POSITIVE NEGATIVE NORMALE TRACE SANSTRACE MAXHC MAXLC 
%token INFO MAXD
%token <string> VAR
%token <int> INT
%start commande
%type <Types.commande> commande


%%
commande :
| QUITTER FIN{Quitter}
| AIDE FIN{Aide}
| POSITIVE FIN{Positive}
| NEGATIVE FIN{Negative}
| NORMALE FIN{Normale}
| TRACE FIN{Trace}
| SANSTRACE FIN{SansTrace}
| MAXLC INT FIN{MaxLongueurClause $2}
| MAXHC INT FIN{MaxHauteurClause $2}
| INFO FIN{Info}
| MAXD INT FIN{MaxDuree $2}
| PREUVE liste_de_clauses FIN {Preuve $2}
;

liste_de_clauses :
| clause  {[{numero=0;origine = Hyp;corps= $1}]}
| clause VIRGULE liste_de_clauses {{numero=0;origine = Hyp;corps=$1}::$3}
;

clause :
|{[]}
|terme clause{(Pos $1)::$2}
|NON terme clause {(Neg $2)::$3}
;

terme :
| VAR {let x = $1 in if 'a' <= x.[0] && x.[0]<= 'f' then Comp($1,[])else Var $1}
| VAR PARG liste_de_termes PARD {Comp ($1,$3)}
;

liste_de_termes :
| {[]}
| terme fin_liste_de_termes {$1::$2}
;

fin_liste_de_termes :
| {[]}
| VIRGULE terme fin_liste_de_termes {$2::$3}
